/* 
 * Error-correcting Multicast on Open Nodes (EMON)
 *
 * This software is placed in public domain.
 */ 

/*
 * author(s): KASAMATSU Ken-ichi <kasamatu@lab1.kuis.kyoto-u.ac.jp> 
 *            
 * started:   2002/01/24
 *
 * $Id$
 */

#ifndef _EMON_string_h_
#define _EMON_string_h_

#include <sys/types.h>
/* 
   the extension of the standard "strsep".
   this function add # of separated str and wheather
   # of found delim in strp[0] is more than strplen or not
   , to "strsep".

   ret=string_sep(strp,":-/<>",3,&strnum);
   switch(ret){
   case 0:/# succeed #/
   case 1:/# too many delim found #/
   } 
 */
int string_sep(char **strp,const char *delim,int strplen,int *ret_strplen);

/* 
   MEMO:
   if recv packet by multicast. src_addr is multicast address
   if_addr is a addr this host have.
   str="src_addr/src_port/if_addr/ipvar"
 */
int string_sep4udpiprecv(char *str
			 ,char **src_addr,u_int16_t *src_port
			 ,char **if_addr /* for multicast */
			 ,u_int8_t  *ipvar); 


/* 
   MEMO:
   if send packet by multicast. dst_addr is multicast address
   src_addr is a addr this host have.

   str="dst_addr/dst_port/src_addr/src_port/ipvar/ttl"
*/
int string_sep4udpipsend(char *str
			 ,char **dst_addr ,u_int16_t *dst_port
			 ,char **src_addr ,u_int16_t *src_port
			 ,u_int8_t *ipvar
			 ,u_int8_t *ttl);


#endif
