#include <string.h>

/* for test */
#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>

#include "string.h"

int mcastrecvaddrstr_parse(char *str
			   ,char **ret_addr
			   ,u_int16_t *ret_port
			   ,char **ret_ifname){
	char *strptr[3];
	int  len;
	int  ret;
	strptr[0]=str;
	ret=string_sep(strptr,"p/",3,&len);
	switch(len){
	case 3:
		if(*strptr[2]!='\0')
			*ret_ifname=strptr[2];
	case 2:
		if(*strptr[1]!='\0')
			*ret_port=atoi(strptr[1]);
	case 1:
		if(*strptr[0]!='\0')
			*ret_addr=strptr[0];
	}
	return(ret);
}

int main (int argc,char *argv[]){
	char           *src_addr,*dst_addr,*if_addr;
	char           *str;
	u_int16_t       src_port,dst_port;
	u_int8_t        ttl,ipver;
	int              ret;
	int              cnt;

	if(argc!=2){
		printf("usage : %s \n"
		       "udpiprecv: addr/port/ifhint/ipver\n"
		       "udpipsend: addr/port/addr/port/ipver/ttl\n"
		       ,argv[0]);
		return (1);
	}

	cnt=2;
	while(cnt>0){
		src_addr="SRC_ADDR";
		dst_addr="DST_ADDR";
		if_addr="IF_ADDR";
		src_port=321;
		dst_port=123;
		ttl     =255;
		ipver   =0;
		str=strdup(argv[1]);
		switch(cnt){
		case 2:
		ret=string_sep4udpiprecv(
			str
			,&src_addr,&src_port
			,&if_addr,&ipver);
		printf("recv:src_addr=\"%s\" src_port=%u ifhint=\"%s\" "
		       "ipver=%u toomanydelim=%s\n"
		       ,src_addr,src_port,if_addr,ipver,ret?"YES":"NO");
		break;
		case 1:
		ret=string_sep4udpipsend(
			str
			,&dst_addr,&dst_port
			,&src_addr,&src_port
			,&ipver,&ttl);
		printf("send:dst_addr=\"%s\" dst_port=%u "
		       "src_addr=\"%s\" src_port=%u "
		       "ipver=%u ttl=%u toomanydelim=%s\n"
		       ,dst_addr,dst_port
		       ,src_addr,src_port
		       ,ipver,ttl
		       ,ret?"YES":"NO");
		break;
		}
		cnt--;
		printf("==============================\n");
	}
			
	return(0);
}
	
