#include <sys/types.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <fcntl.h>
#include <string.h>

#include "pipe_hd.h"
#include "time.h"
#include "debug.h"

void usage();

int
main(int argc, char *argv[])
{
	char ch;
#define EPI_BUFSIZE 65536 /* EMON PIPEINFO BUFSIZE */
	char buf[EPI_BUFSIZE];
	pipe_hd_t *phdr = (pipe_hd_t*)buf;
	int len, len2;
	//	fd_set rfds;

	time_tv_t timeofday,timeofemon,difftv;
	time_clkofemon_t clkofemon;

	while ((ch = getopt(argc, argv, "h")) != -1) {
		switch (ch) {
		case 'h':
		default:
			usage();
		}
	}

	/*fcntl(0, F_SETFL, fcntl(0, F_GETFL)|O_NONBLOCK);*/
	for (;;) {
#if 0
		FD_ZERO(&rfds);
		FD_SET(0, &rfds);
		select(0+1, &rfds, NULL, NULL, NULL);
#endif
		len = fd_read_ignoreEOF(0, buf, PIPE_HEADER_LEN);
		fprintf(stderr, "EMON header(len=%d)\n", len);
		if (len != PIPE_HEADER_LEN) {
			fprintf(stderr, "EMON header error (len=%d)\n", len);
			exit(1);
		}
		len = ntohl(phdr->vmlen)&0x00ffffff;
		if (PIPE_HEADER_LEN + len > EPI_BUFSIZE) {
			fprintf(stderr, "buffer overflow (len=%d)\n", len);
			exit(1);
		}
/* 		len2 = fd_read_ignoreEOF(0, buf + PIPE_HEADER_LEN, len); */
/* 		if (len2 != len) { */
/* 			fprintf(stderr,  */
/* 				"size is illeagal len=%d, len2=%d\n",  */
/* 				len, len2); */
/* 			exit(1); */
/* 		} */
		while(time_updateclkofemon(0,&clkofemon)==0);
		fprintf(stderr, "EMON (paylen=%d)\n", len);
		timeofday =time_gettimeofday();
		fprintf(stderr, "EMON (paylen=%d)\n", len);
		timeofemon=time_gettimeofemon(clkofemon);
		fprintf(stderr, "EMON (paylen=%d)\n", len);
		difftv=time_subtv(timeofemon,timeofday);
		fprintf(stderr, 
			"timeof: day{%ld,%ld} emon{%ld,%ld} \n"
			"emon-d  dif{%ld,%ld}\n"
			,timeofday.sec,timeofday.usec
			,timeofemon.sec,timeofemon.usec
			,difftv.sec,difftv.usec
			);
	}

	return (0);
}

void usage()
{
	fprintf(stderr, "usage: pipeinfo\n");
	exit(1);
}
